# This is the jni directory.
LOCAL_PATH := $(call my-dir)

# This file is to be generated by CMake.  We reference files within this
# Allegro source tree and not installed into the toolchain directory,
# which complicates things slightly.
include $(LOCAL_PATH)/localgen.mk

# Declare Allegro libraries, which are NOT built with ndk-build.
include $(CLEAR_VARS)
LOCAL_MODULE := allegro
LOCAL_SRC_FILES := $(RELATIVE_LIB_DIR)/lib$(LOCAL_MODULE)$(LIB_TYPE_SUFFIX).so
LOCAL_EXPORT_C_INCLUDES := $(CMAKE_SOURCE_DIR)/include
LOCAL_EXPORT_C_INCLUDES += $(CMAKE_BINARY_DIR)/include
LOCAL_EXPORT_C_LDLIBS := -llog
LOCAL_EXPORT_CFLAGS := -DDEBUGMODE
include $(PREBUILT_SHARED_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := allegro_image
LOCAL_SRC_FILES := $(RELATIVE_LIB_DIR)/lib$(LOCAL_MODULE)$(LIB_TYPE_SUFFIX).so
LOCAL_EXPORT_C_INCLUDES += $(CMAKE_SOURCE_DIR)/addons/image
include $(PREBUILT_SHARED_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := allegro_primitives
LOCAL_SRC_FILES := $(RELATIVE_LIB_DIR)/lib$(LOCAL_MODULE)$(LIB_TYPE_SUFFIX).so
LOCAL_EXPORT_C_INCLUDES := $(CMAKE_SOURCE_DIR)/addons/primitives
include $(PREBUILT_SHARED_LIBRARY)

# Declare our application.
# Source files are relative to $(LOCAL_PATH).
include $(CLEAR_VARS)
LOCAL_MODULE    := example
LOCAL_SRC_FILES := ../csrc/main.c
LOCAL_CFLAGS    += -W -Wall
LOCAL_SHARED_LIBRARIES := allegro
LOCAL_SHARED_LIBRARIES += allegro_image
LOCAL_SHARED_LIBRARIES += allegro_primitives
include $(BUILD_SHARED_LIBRARY)
